/*
 * MD5 Password Encryption/Comparison routines by David Irving, Fred Brittain,
 * and Aaron Gagnon --  University of Maine Farmington
 * Donated to the RedHat Directory Server Project 2005-06-10 
 */

#include <string.h>
#include <sys/types.h>
#include <stdio.h>
#include <pk11func.h>
#include <nss.h>
#include <base64.h>
#include "pwdstorage.h"

int
md5_pw_cmp( char *userpwd, char *dbpwd )
{
   int rc=-1;
   char * bver;
   PK11Context *ctx=NULL;
   unsigned int outLen;
   unsigned char hash_out[20];

   NSS_NoDB_Init(".");
   ctx = PK11_CreateDigestContext(SEC_OID_MD5);
   PK11_DigestBegin(ctx);
   PK11_DigestOp(ctx, userpwd, strlen(userpwd));
   PK11_DigestFinal(ctx, hash_out, &outLen, sizeof hash_out);
   bver = BTOA_DataToAscii(hash_out, outLen);
   PK11_DestroyContext(ctx, 1);
   rc = strcmp(bver,dbpwd);   
   return rc;
}

char *
md5_pw_enc( char *pwd )
{
   char * bver, *enc=NULL;
   PK11Context *ctx=NULL;
   unsigned int outLen;
   unsigned char hash_out[20];

   NSS_NoDB_Init(".");
   ctx = PK11_CreateDigestContext(SEC_OID_MD5);
   PK11_DigestBegin(ctx);
   PK11_DigestOp(ctx, pwd, strlen(pwd));
   PK11_DigestFinal(ctx, hash_out, &outLen, sizeof hash_out);
   bver = BTOA_DataToAscii(hash_out, outLen);
   PK11_DestroyContext(ctx, 1);
   enc = slapi_ch_smprintf("%c%s%c%s", PWD_HASH_PREFIX_START, MD5_SCHEME_NAME, PWD_HASH_PREFIX_END, bver );
   sprintf(enc, "%c%s%c%s", PWD_HASH_PREFIX_START,MD5_SCHEME_NAME,PWD_HASH_PREFIX_END,bver);
   return( enc );
}

